package com.zswl.cloud.springBtach.server.core.api.dfy;

import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONUtil;
import com.zswl.cloud.springBatch.client.model.dfy.request.*;
import com.zswl.cloud.springBatch.client.model.dfy.response.*;
import com.zswl.cloud.springBtach.server.core.dao.ApiLogDao;
import com.zswl.cloud.springBtach.server.core.domain.ApiLog;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class DiFengYunApi {

    @Autowired
    ApiLogDao apiLogDao;

    @Value("${dfy.host}")
    private String host;

    @Value("${dfy.mp.secretkey}")
    private String secretKey;


    @Value("${dfy.mp.apikey}")
    private String apiKey;

    public DiFengYunApi(ApiLogDao apiLogDao) {
        this.apiLogDao = apiLogDao;
    }

    // 景点列表查询

    public ScenicListResponse scenicList(ScenicListRequest scenicRequest) {

        String post = post(scenicRequest, "/Ticket/scenicList");

        return JSONUtil.toBean(post, ScenicListResponse.class);

    }


    // 景点详情接口

    public ScenicDetailResponse scenicDetail(ScenicDetailRequest scenicDetailRequest) {

        String post = post(scenicDetailRequest, "/Ticket/scenicDetail");
        return JSONUtil.toBean(post, ScenicDetailResponse.class);
    }

    // 特权门票查询接口
    public PrivilegeTicketListResponse privilegeTicketList(PrivilegeTicketListRequest privilegeTicketListRequest) {

        String post = post(privilegeTicketListRequest, "/Ticket/privilegeTicketList");
        return JSONUtil.toBean(post, PrivilegeTicketListResponse.class);
    }


    // 门票详情接口
    public DetailResponse detail(DetailRequest detailRequest) {

        String post = post(detailRequest, "/Ticket/detail");
        return JSONUtil.toBean(post, DetailResponse.class);
    }


    // 创建订单接口
    public CreateOrderNewResponse createOrderNew(CreateOrderNewRequest createOrderNewRequest) {

        String post = post(createOrderNewRequest, "/Ticket/createOrderNew");
        return JSONUtil.toBean(post, CreateOrderNewResponse.class);
    }


    // 取消订单
    public void cancelOrder(CancelOrderRequest cancelOrderRequest) {
        post(cancelOrderRequest, "/Ticket/cancelOrder");
    }


    // 出票(代扣)接口
    public SubmitOrderResponse SubmitOrderResponse(SubmitOrderRequest submitOrderRequest) {
        String post = post(submitOrderRequest, "/Ticket/submitOrder");
        return JSONUtil.toBean(post, SubmitOrderResponse.class);
    }


    private String post(DfyRequestBase dfyRequestBase, String url) {


        dfyRequestBase.setApiKey(apiKey);
        String signature = Signature.getSignature(JSONUtil.parseObj(dfyRequestBase), secretKey);
        dfyRequestBase.setSign(signature);

        String post = HttpUtil.post(host + url, JSONUtil.toJsonStr(dfyRequestBase));
        ApiLog apiLog = new ApiLog();
        apiLog.setSystem("difengyun");
        apiLog.setService(url);
        apiLog.setRequest(post);
        apiLog.setResponse(JSONUtil.toJsonStr(post));
        apiLogDao.save(apiLog);
        return post;

    }


}
